
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Thread.h"
#include "Unit1.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall TMyThread::TMyThread(bool CreateSuspended): TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------

void __fastcall TMyThread::Execute(void)
{
    char szBuffer[MAX_BUFF+1];
    SOCKET  sock;
    WSADATA wsaData;
    SOCKADDR_IN sockaddr;
    WORD    wVersionRequested;
    int     rVal;

    wVersionRequested = MAKEWORD( 1, 1 );
    if ( (rVal = WSAStartup( wVersionRequested, &wsaData)) != 0 ) {
        Application->MessageBoxA("UDP Server Error", "Error", MB_OK|MB_ICONEXCLAMATION );
        WSACleanup();
        return;
    }

    memset( &sockaddr, 0, sizeof(sockaddr) );

    // |[gԍݒ
    sockaddr.sin_port = 1200;

    // Internet
    sockaddr.sin_family = AF_INET;

    // any address
    sockaddr.sin_addr.s_addr = htonl( INADDR_ANY );

    // socketI[v
    sock = socket( AF_INET, SOCK_DGRAM, 0 );
    if ( sock == INVALID_SOCKET ) {
        Application->MessageBoxA("UDP Server Error", "Error", MB_OK|MB_ICONEXCLAMATION );
        WSACleanup();
        return;
    }

    // bind
    rVal = bind( sock, (LPSOCKADDR)&sockaddr, sizeof(sockaddr) );
    if ( rVal == SOCKET_ERROR ) {
        Application->MessageBoxA("UDP Server Error", "Error", MB_OK|MB_ICONEXCLAMATION );
        closesocket( sock );
        WSACleanup();
        return;
    }

    lbEtherRcvSts->Color = clLime;           /* \Pbg\΂ɂ */

    // f[^MA\
    while( true ) {
        rVal = recvfrom( sock, szBuffer, MAX_BUFF, 0, NULL, NULL );
        if ( rVal == SOCKET_ERROR ) {
            Application->MessageBoxA("UDP Server Error", "Error", MB_OK|MB_ICONEXCLAMATION );
            closesocket( sock );
            WSACleanup();
            lbEtherRcvSts->Color = clRed;    /* \Pbg\Ԃ */
            return;
        }else {
            // Mf[^
        }
    }
    closesocket( sock );
    WSACleanup();
    lbEtherRcvSts->Color = clRed;            /* \Pbg\Ԃ */

}
//---------------------------------------------------------------------------
