//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------

// RMAPwb_[
struct strRmapHed
{
    int PathNum;
    BYTE PathAddr[32];
    BYTE TargetAddr;
    BYTE Command;
    BYTE Key;
    int ReplyNum;
    BYTE ReplyAddr[16];
    BYTE InitiaterAddr;
    WORD Transaction;
    DWORD RmapAddr;
    DWORD RmapDataSize;
};


class TForm1 : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    TPanel *Panel2;
    TGroupBox *GroupBox1;
    TLabel *Label5;
    TLabel *Label6;
    TEdit *IP0;
    TEdit *IP1;
    TEdit *IP2;
    TEdit *IP3;
    TEdit *Port;
    TLabel *Label7;
    TLabel *Label8;
    TLabel *Label9;
    TButton *btEtherPort;
    TOpenDialog *OpenDialog1;
    TPageControl *target;
    TTabSheet *Main;
    TPanel *Panel4;
    TPanel *Panel6;
    TListBox *lbLog;
    TMemo *RepData;
    TLabel *Label2;
    TLabel *Label15;
    TGroupBox *GroupBox4;
    TLabel *Label14;
    TLabel *Label16;
    TLabel *Label17;
    TLabel *Label18;
    TLabel *Label19;
    TEdit *edInitiatorLogAddr;
    TEdit *edTargetSpwAddr;
    TEdit *edKey;
    TEdit *edTransactionId;
    TEdit *edAddr;
    TEdit *edDataLen;
    TComboBox *Replay_address_list;
    TComboBox *Instruction_list;
    TEdit *Replay_address00;
    TEdit *Replay_address01;
    TEdit *Replay_address02;
    TEdit *Replay_address03;
    TEdit *Replay_address10;
    TEdit *Replay_address11;
    TEdit *Replay_address12;
    TEdit *Replay_address13;
    TEdit *Replay_address20;
    TEdit *Replay_address21;
    TEdit *Replay_address22;
    TEdit *Replay_address23;
    TEdit *edSpwPathAddr;
    TRadioGroup *RMAP_Command_select;
    TButton *btnSend;
    TButton *btnReplayClear;
    TCheckBox *cb12byte;
    TCheckBox *cbHeader;
    TEdit *edByte;
    TLabel *Label29;
    TEdit *edWriteDataFilePath;
    TButton *btWriteFile;
    TEdit *edWriteData;
    TLabel *lbEther;
    TGroupBox *GroupBox2;
    TButton *btExit;
    TLabel *Label1;
    TCheckBox *cb32bit;
    TPanel *Panel1;
    TButton *HedButton;
    TButton *btLogClear;
    TTabSheet *Macro;
    TPanel *Panel3;
    TGroupBox *GroupBox3;
    TButton *MacSelButton;
    TEdit *MacroFileEdit;
    TButton *MacroButton;
    TGroupBox *GroupBox5;
    TEdit *edTime;
    TLabel *Label3;
    TButton *TimeSend;
    TLabel *Label4;
    TEdit *EdErrCnt;
    TCheckBox *ChkErrLoop;
    TEdit *EdTimeCount;
    TLabel *Label10;
    void __fastcall Rmap_Command_select_click(TObject *Sender);
    void __fastcall From_Create(TObject *Sender);
    void __fastcall btEtherPortClick(TObject *Sender);
    void __fastcall RepAddrChange(TObject *Sender);
    void __fastcall btnSendClick(TObject *Sender);
    void __fastcall btnReplayClearClick(TObject *Sender);
    void __fastcall btSet3Click(TObject *Sender);
    void __fastcall btWriteFileClick(TObject *Sender);
    void __fastcall btTraMemTPClick(TObject *Sender);
    void __fastcall btTraFrontTPClick(TObject *Sender);
    void __fastcall btExitClick(TObject *Sender);
    void __fastcall Button2Click(TObject *Sender);
    void __fastcall HedButtonClick(TObject *Sender);
    void __fastcall MacSelButtonClick(TObject *Sender);
    void __fastcall MacroButtonClick(TObject *Sender);
    void __fastcall btLogClearClick(TObject *Sender);
    void __fastcall TimeSendClick(TObject *Sender);
private:	// [U[錾
    TThread* mRunThread;
    struct strRmapHed RmapHed;
public:		// [U[錾
    __fastcall TForm1(TComponent* Owner);
    void __fastcall TForm1::AddLog(AnsiString LogMsg);
    unsigned char RMAP_CalculateCRC(char *buf, unsigned int len, int crcType);
    int TForm1::TcpIpHeadSend(unsigned long len);
    void TForm1::TcpIpDataSend(void);
    void TForm1::SpwPathAddrSend(void);
    unsigned long TForm1::atohex(unsigned char *buf, int endcnt);
    void TForm1::WriteDataSend(void);
    void TForm1::crePort1(void);
    void TForm1::RepAddrChangeMain(void);
    void __fastcall TForm1::Rmap_Command_select_main(void);

    void TForm1::rdMain(void);  // wb_[荞
    void TForm1::rdPort(void);  // PortX wb_[荞
    void TForm1::crePort(void); // PortX wb_[񐶐


    int TForm1::ReadHedFile(char *FileName, int flag);
    void TForm1::UpdateHed(char *FileName, int flag);
	void TForm1::makePathAddr(char *buf, int flag);
	void TForm1::makeTargetAddr(char *buf, int flag);
	void TForm1::makeKey(char *buf, int flag);
	void TForm1::makePeplyAddr(char *buf, int flag);
	void TForm1::makeInitiator(char *buf, int flag);
	void TForm1::makeTranszction(char *buf, int flag);
	void TForm1::makeRmapAddr(char *buf, int flag);
	void TForm1::makeDataSize(char *buf, int flag);

    void TForm1::MacError(int line, int flag);
    void TForm1::MacResp(int flag, int line, char *msg);
    int TForm1::MacComp(void);
    int TForm1::MacWrite(void);
    int TForm1::MacRead(void);

    void TForm1::WriteDataRand(void);
    int TForm1::MacWriteRand(void);
    int TForm1::MacCompRand(void);


    // 32bit
    int TForm1::Write32bit(int addr, int wData, int flg);

    // f[^M
    int TForm1::DataRead(int addr, int dLen, int flg);
    int TForm1::RcvWait(void);  // M҂

    // TCP/IP to Gbit2SpW
    void TForm1::TcpIpSend_h_m(void);
    void TForm1::SpwPathAddrSend_m(void);
    void TForm1::WriteDataSend_m(void);

    // TraGen@\
    void TForm1::TraGenSend(void);
    void TForm1::TraGenRun(void);
    void TForm1::TraGenRead(int waitflg);

    // Ether
    int EtherOpen;
    unsigned long IP_Addr;
    char sData[1024];
    unsigned char PacketCRCDraftE;
    unsigned char PacketCRCDraftF;
    int dstSocket;
    int StartFlg;
    int RamTestFlg;
    unsigned char cmpData[1500];
    unsigned char Buf[128];
    int SendLength;
    AnsiString BaseFilePath;
    int RcvFlg;  // MtO

    // 32bit
    unsigned char rcvData[1500];
    int           rcvLen;

    // Thread
    int ThreadFlg;
    int ThreadExe;

    struct rmap_h_struct {
      unsigned char t_spw_addr;
      unsigned char instruct;
      unsigned char key;
      unsigned char rep_addr_len;
      unsigned char rep_addr[12];
      unsigned char i_spw_addr;
      unsigned char tra_id[2];
      unsigned char addr[4];
      unsigned long addr32bit;
      unsigned char d_len[3];
      unsigned long d_len32bit;
      unsigned char h_size;
    };
//    } rmap_h_m;

    struct rmap_h_struct rmap_h_m;
    struct rmap_h_struct rmap_h_p;
    AnsiString rmap_spw_path_m;
    AnsiString rmap_spw_path_p;

    // Esc
    int EscFlg;
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
